#!/usr/bin/env python3

import math, sys
import SAT_lib, my_utils

#SIZE=5 # OK
#SIZE=6 # unsat
#SIZE=7 # OK

SIZE=int(sys.argv[1])
print ("SIZE:", SIZE)

s=SAT_lib.SAT_lib(seed=1234)

a=[[s.alloc_BV(SIZE) for c in range(SIZE)] for r in range(SIZE)]

def make_distinct_one_hots(s, lst):
    [s.OR_always(list(t)) for t in zip(*lst)]

for r in range(SIZE):
    for c in range(SIZE):
        s.make_one_hot(a[r][c])

# all numbers in all rows must be distinct:
for r in range(SIZE):
    make_distinct_one_hots(s, [a[r][c] for c in range(SIZE)])

# ... in all columns as well:
for c in range(SIZE):
    make_distinct_one_hots(s, [a[r][c] for r in range(SIZE)])

# diagonals, incl. broken:
for r in range(SIZE):
    t=[]
    for r2 in range(SIZE):
        t.append(a[(r+r2) % SIZE][r2 % SIZE])
    make_distinct_one_hots(s, t)

for r in range(SIZE):
    t=[]
    for r2 in range(SIZE):
        t.append (a[(r+r2) % SIZE][SIZE-1-(r2 % SIZE)])
    make_distinct_one_hots(s, t)

if s.solve()==False:
    print ("unsat")
    exit(0)

def print_square(a):
    for r in range(SIZE):
        l=""
        for c in range(SIZE):
            l=l+str(int(math.log(SAT_lib.BV_to_number(s.get_BV_from_solution(a[r][c])), 2)))+" "
        print (l)

print_square (a)

