#!/usr/bin/env python3

import math, sys, time
import SAT_lib, my_utils

print ("usage: SIZE SEED NORMALIZE")
print ("NORMALIZE: [0|1]")
print ("")

SIZE=int(sys.argv[1])
print ("SIZE:", SIZE)

_seed=int(sys.argv[2])
print ("seed: ", _seed)

if sys.argv[3]=="1":
    NORMALIZE=True
elif sys.argv[3]=="0":
    NORMALIZE=False
else:
    raise AssertionError

start_t=time.time()
print ("time at start: ", start_t)

s=SAT_lib.SAT_lib(seed=_seed)

a=[[s.alloc_BV(SIZE) for c in range(SIZE)] for r in range(SIZE)]

def make_distinct_one_hots(s, lst):
    [s.OR_always(list(t)) for t in zip(*lst)]

for r in range(SIZE):
    for c in range(SIZE):
        s.make_one_hot(a[r][c])

# all numbers in all rows must be distinct:
for r in range(SIZE):
    make_distinct_one_hots(s, [a[r][c] for c in range(SIZE)])

# ... in all columns as well:
for c in range(SIZE):
    make_distinct_one_hots(s, [a[r][c] for r in range(SIZE)])

if NORMALIZE:
    print ("normalized")
    # fix all rows and columns to [0..9...]
    for i in range(SIZE):
        tmp=SAT_lib.n_to_BV(1 << i, SIZE)
        s.fix_BV(a[0][i], tmp)
        s.fix_BV(a[i][0], tmp)

_09=list(map(chr, range(ord('0'), ord('9')+1)))
_az=list(map(chr, range(ord('a'), ord('z')+1)))
_09_az=_09+_az

def print_square(s, a):
    for r in range(SIZE):
        l=""
        for c in range(SIZE):
            l=l+_09_az[int(math.log(SAT_lib.BV_to_number(s.get_BV_from_solution(a[r][c])), 2))]+" "
        print (l)

sol=0

if s.solve():
    while True:
        sol=sol+1
        print ("*** solution %d, seconds from start %d" % (sol, time.time()-start_t))
        print_square (s, a)
        print ("")
        sys.stdout.flush()
        #exit(0)
        if s.fetch_next_solution()==False:
            break

print ("solutions: %d" % sol)

